package com.zcloud.controller.speEquip;

import com.zcloud.controller.base.BaseController;
import com.zcloud.entity.Page;
import com.zcloud.entity.PageData;
import com.zcloud.logs.LogAnno;
import com.zcloud.service.speEquip.SpecialEquipmentChangeService;
import com.zcloud.util.DateUtil;
import com.zcloud.util.Jurisdiction;
import com.zcloud.util.ObjectExcelView;
import com.zcloud.util.Tools;
import org.apache.shiro.authz.annotation.RequiresPermissions;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Controller;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.ResponseBody;
import org.springframework.web.servlet.ModelAndView;

import java.util.*;

/**
 * 说明：特种设备变更记录
 * 作者：luoxiaobao
 * 时间：2021-06-19
 * 官网：www.zcloudchina.com
 */
@Controller
@RequestMapping("/specialequipmentchange")
public class SpecialEquipmentChangeController extends BaseController {

	@Autowired
	private SpecialEquipmentChangeService specialequipmentchangeService;

	/**新增
	 * @param
	 * @throws Exception
	 */
	@RequestMapping(value="/add")
	// @RequiresPermissions("specialequipmentchange:add")
	@ResponseBody
	@LogAnno(menuType= "综合管理",menuServer= "特种设备",instructionsOperate = "设备变更记录",instructionsType = "新增")
	public Object add() throws Exception{
		Map<String,Object> map = new HashMap<String,Object>();
		String errInfo = "success";
		PageData pd = new PageData();
		pd = this.getPageData();
		pd.put("SPECIALEQUIPMENTCHANGE_ID", this.get32UUID());	//主键
		pd.put("CREATOR", Jurisdiction.getUsername());	//添加人
		pd.put("CREATTIME", DateUtil.date2Str(new Date()));	//添加时间
		pd.put("OPERATOR", Jurisdiction.getUsername());	//修改人
		pd.put("OPERATTIME", DateUtil.date2Str(new Date()));	//修改时间
		pd.put("ISDELETE", "0");	//是否删除 1-是  0-否
		pd.put("CORPINFO_ID", Jurisdiction.getCORPINFO_ID());	//企业ID
		specialequipmentchangeService.save(pd);
		map.put("pd", pd);
		map.put("result", errInfo);
		return map;
	}

	/**删除
	 * @param
	 * @throws Exception
	 */
	@RequestMapping(value="/delete")
	// @RequiresPermissions("specialequipmentchange:del")
	@ResponseBody
	@LogAnno(menuType= "综合管理",menuServer= "特种设备",instructionsOperate = "设备变更记录",instructionsType = "删除")
	public Object delete() throws Exception{
		Map<String,String> map = new HashMap<String,String>();
		String errInfo = "success";
		PageData pd = new PageData();
		pd = this.getPageData();
		pd.put("OPERATOR", Jurisdiction.getUsername());	//修改人
		pd.put("OPERATTIME", DateUtil.date2Str(new Date()));	//修改时间
		specialequipmentchangeService.delete(pd);
		map.put("result", errInfo);				//返回结果
		return map;
	}

	/**修改
	 * @param
	 * @throws Exception
	 */
	@RequestMapping(value="/edit")
	// @RequiresPermissions("specialequipmentchange:edit")
	@ResponseBody
	@LogAnno(menuType= "综合管理",menuServer= "特种设备",instructionsOperate = "设备变更记录",instructionsType = "修改")
	public Object edit() throws Exception{
		Map<String,Object> map = new HashMap<String,Object>();
		String errInfo = "success";
		PageData pd = new PageData();
		pd = this.getPageData();
		pd.put("OPERATOR", Jurisdiction.getUsername());	//修改人
		pd.put("OPERATTIME", DateUtil.date2Str(new Date()));	//修改时间
		specialequipmentchangeService.edit(pd);
		map.put("pd", pd);
		map.put("result", errInfo);
		return map;
	}

	/**列表
	 * @param page
	 * @throws Exception
	 */
	@RequestMapping(value="/list")
	// @RequiresPermissions("specialequipmentchange:list")
	@ResponseBody
	@LogAnno(menuType= "综合管理",menuServer= "特种设备",instructionsOperate = "设备变更记录",instructionsType = "列表")
	public Object list(Page page) throws Exception{
		Map<String,Object> map = new HashMap<String,Object>();
		String errInfo = "success";
		PageData pd = new PageData();
		pd = this.getPageData();
		String KEYWORDS = pd.getString("KEYWORDS");						//关键词检索条件
		if(Tools.notEmpty(KEYWORDS))pd.put("KEYWORDS", KEYWORDS.trim());
		pd.put("CORPINFO_ID", Jurisdiction.getCORPINFO_ID());	//企业ID
		page.setPd(pd);
		List<PageData>	varList = specialequipmentchangeService.list(page);	//列出SpecialEquipmentChange列表
		map.put("varList", varList);
		map.put("page", page);
		map.put("result", errInfo);
		return map;
	}

	/**去修改页面获取数据
	 * @param
	 * @throws Exception
	 */
	@RequestMapping(value="/goEdit")
	// @RequiresPermissions("specialequipmentchange:edit")
	@ResponseBody
	@LogAnno(menuType= "综合管理",menuServer= "特种设备",instructionsOperate = "设备变更记录",instructionsType = "去修改页面获取数据")
	public Object goEdit() throws Exception{
		Map<String,Object> map = new HashMap<String,Object>();
		String errInfo = "success";
		PageData pd = new PageData();
		pd = this.getPageData();
		pd = specialequipmentchangeService.findById(pd);	//根据ID读取
		map.put("pd", pd);
		map.put("result", errInfo);
		return map;
	}

	/**批量删除
	 * @param
	 * @throws Exception
	 */
	@RequestMapping(value="/deleteAll")
	// @RequiresPermissions("specialequipmentchange:del")
	@ResponseBody
	@LogAnno(menuType= "综合管理",menuServer= "特种设备",instructionsOperate = "设备变更记录",instructionsType = "批量删除")
	public Object deleteAll() throws Exception{
		Map<String,Object> map = new HashMap<String,Object>();
		String errInfo = "success";
		PageData pd = new PageData();
		pd = this.getPageData();
		pd.put("OPERATOR", Jurisdiction.getUsername());	//修改人
		pd.put("OPERATTIME", DateUtil.date2Str(new Date()));	//修改时间
		String DATA_IDS = pd.getString("DATA_IDS");
		if(Tools.notEmpty(DATA_IDS)){
			String ArrayDATA_IDS[] = DATA_IDS.split(",");
			pd.put("ArrayDATA_IDS", ArrayDATA_IDS);	//待删除ids
			specialequipmentchangeService.deleteAll(pd);
			errInfo = "success";
		}else{
			errInfo = "error";
		}
		map.put("result", errInfo);				//返回结果
		return map;
	}

	/**导出到excel
	 * @param
	 * @throws Exception
	 */
	@RequestMapping(value="/excel")
	// @RequiresPermissions("toExcel")
	@LogAnno(menuType= "综合管理",menuServer= "特种设备",instructionsOperate = "设备变更记录",instructionsType = "导出到excel")
	public ModelAndView exportExcel() throws Exception{
		ModelAndView mv = new ModelAndView();
		PageData pd = new PageData();
		pd = this.getPageData();
		Map<String,Object> dataMap = new HashMap<String,Object>();
		List<String> titles = new ArrayList<String>();
		titles.add("特种设备ID");	//1
		titles.add("操作类型（新增、删除、废弃等）");	//2
		titles.add("添加人");	//3
		titles.add("添加时间");	//4
		titles.add("修改人");	//5
		titles.add("修改时间");	//6
		titles.add("是否删除(0:有效 1：删除)");	//7
		titles.add("设备名称（前）");	//8
		titles.add("设备名称（后）");	//9
		titles.add("设备型号（前）");	//10
		titles.add("设备型号（后）");	//11
		titles.add("设备代码（前）");	//12
		titles.add("设备代码（后）");	//13
		titles.add("出厂编号（前）");	//14
		titles.add("出厂编号（后）");	//15
		titles.add("设备类型（前）");	//16
		titles.add("设备类型（后）");	//17
		titles.add("设备状态（前）");	//18
		titles.add("设备状态（后）");	//19
		titles.add("设备使用地点（前）");	//20
		titles.add("设备使用地点（后）");	//21
		titles.add("设备责任单位（前）");	//22
		titles.add("设备责任单位（后）");	//23
		titles.add("设备负责人（前）");	//24
		titles.add("设备负责人（后）");	//25
		titles.add("负责人联系电话（前）");	//26
		titles.add("负责人联系电话（后）");	//27
		titles.add("下次检验日期（前）");	//28
		titles.add("下次检验日期（后）");	//29
		titles.add("设备技术档案（附件）（前）");	//30
		titles.add("设备技术档案（附件）（后）");	//31
		titles.add("设备技术档案（附件）（前）");	//32
		titles.add("设备技术档案（附件）（后）");	//33
		titles.add("备注（前）");	//34
		titles.add("备注（后）");	//35
		dataMap.put("titles", titles);
		pd.put("CORPINFO_ID", Jurisdiction.getCORPINFO_ID());	//企业ID
		List<PageData> varOList = specialequipmentchangeService.listAll(pd);
		List<PageData> varList = new ArrayList<PageData>();
		for(int i=0;i<varOList.size();i++){
			PageData vpd = new PageData();
			vpd.put("var1", varOList.get(i).getString("SPECIALEQUIPMENT_ID"));	    //1
			vpd.put("var2", varOList.get(i).getString("OPERATETYPE"));	    //2
			vpd.put("var3", varOList.get(i).getString("CREATOR"));	    //3
			vpd.put("var4", varOList.get(i).getString("CREATTIME"));	    //4
			vpd.put("var5", varOList.get(i).getString("OPERATOR"));	    //5
			vpd.put("var6", varOList.get(i).getString("OPERATTIME"));	    //6
			vpd.put("var7", varOList.get(i).get("ISDELETE").toString());	//7
			vpd.put("var8", varOList.get(i).getString("EQUIPMENTNAME_BEFORE"));	    //8
			vpd.put("var9", varOList.get(i).getString("EQUIPMENTNAME_AFTER"));	    //9
			vpd.put("var10", varOList.get(i).getString("EQUIPMENTMODEL_BEFORE"));	    //10
			vpd.put("var11", varOList.get(i).getString("EQUIPMENTMODEL_AFTER"));	    //11
			vpd.put("var12", varOList.get(i).getString("EQUIPMENTCODE_BEFORE"));	    //12
			vpd.put("var13", varOList.get(i).getString("EQUIPMENTCODE_AFTER"));	    //13
			vpd.put("var14", varOList.get(i).getString("FACTORYCODE_BEFORE"));	    //14
			vpd.put("var15", varOList.get(i).getString("FACTORYCODE_AFTER"));	    //15
			vpd.put("var16", varOList.get(i).getString("EQUIPMENTTYPE_BEFORE"));	    //16
			vpd.put("var17", varOList.get(i).getString("EQUIPMENTTYPE_AFTER"));	    //17
			vpd.put("var18", varOList.get(i).getString("EQUIPMENTSTATE_BEFORE"));	    //18
			vpd.put("var19", varOList.get(i).getString("EQUIPMENTSTATE_AFTER"));	    //19
			vpd.put("var20", varOList.get(i).getString("EQUIPMENTUSEPLACE_BEFORE"));	    //20
			vpd.put("var21", varOList.get(i).getString("EQUIPMENTUSEPLACE_AFTER"));	    //21
			vpd.put("var22", varOList.get(i).getString("RESPONSIBLEUNIT_BEFORE"));	    //22
			vpd.put("var23", varOList.get(i).getString("RESPONSIBLEUNIT_AFTER"));	    //23
			vpd.put("var24", varOList.get(i).getString("PERSONCHARGE_BEFORE"));	    //24
			vpd.put("var25", varOList.get(i).getString("PERSONCHARGE_AFTER"));	    //25
			vpd.put("var26", varOList.get(i).getString("PERSONCHARGEPHONE_BEFORE"));	    //26
			vpd.put("var27", varOList.get(i).getString("PERSONCHARGEPHONE_AFTER"));	    //27
			vpd.put("var28", varOList.get(i).getString("NEXTINSPECTIONDATE_BEFORE"));	    //28
			vpd.put("var29", varOList.get(i).getString("NEXTINSPECTIONDATE_AFTER"));	    //29
			vpd.put("var30", varOList.get(i).getString("TECHNICALFILENAME_BEFORE"));	    //30
			vpd.put("var31", varOList.get(i).getString("TECHNICALFILENAME_AFTER"));	    //31
			vpd.put("var32", varOList.get(i).getString("TECHNICALFILEPATH_BEFORE"));	    //32
			vpd.put("var33", varOList.get(i).getString("TECHNICALFILEPATH_AFTER"));	    //33
			vpd.put("var34", varOList.get(i).getString("REMARKS_BEFORE"));	    //34
			vpd.put("var35", varOList.get(i).getString("REMARKS_AFTER"));	    //35
			varList.add(vpd);
		}
		dataMap.put("varList", varList);
		ObjectExcelView erv = new ObjectExcelView();
		mv = new ModelAndView(erv,dataMap);
		return mv;
	}

}
